<?php
/*
   EasyWebshop API Connector
   Copyright (c) 2016 Jan Van Liedekerke

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

   Documentation: https://www.easywebshop.com/doc/api
*/
function easyApp($data = '') {

	// Contact us for your own appkey
	$appkey = 'P@ssw0rd321'; // keep this variable in local function for extra security

	// No need to change anything below. You can watch, but you can't touch!
	if (isset($_REQUEST['shop_id']) && $_REQUEST['shop_id'] && is_numeric($_REQUEST['shop_id'])) {

		$settings = new SimpleXMLElement(file_get_contents(dirname(__FILE__) . '/settings.xml'));
		$method	  = isset($data['function']) && substr($data['function'], 0, 3) == 'set' ? 'PUT' : 'GET';
		$format   = isset($data['format']) && in_array(strtolower($data['format']), array('json', 'xml')) ? strtolower($data['format']) : 'array';
		$data     = is_array($data) ? ($method == 'GET' ? http_build_query($data) : json_encode($data)) : '';
		$apiurl	  = 'https://www.easywebshop.com/api/app/' . $_REQUEST['shop_id'] . ($method == 'GET' && $data ? '?' . $data : ''); // HTTPS only
		$opts     = array(
			'http' => array(
				'header' => array('Authorization: Basic ' . base64_encode($settings->name . ':' . sha1($_REQUEST['shop_id'] . $settings->name . $appkey . $data))),
				'method' => $method,
			)
		);
		if ($method == 'PUT') { $opts['http']['content'] = $data; }
		$response = file_get_contents($apiurl, false, stream_context_create($opts));
		$appdata  = $format == 'array' ? json_decode($response, true) : $response;

		// Output log - only in debug mode
		if (defined('APP_DEBUG') && APP_DEBUG) {
			echo "<pre>\n----------------------------------------------------------------\n\t" . $settings->name .
				" log\n----------------------------------------------------------------\n\n* Accessing API: " .
				$apiurl . "\n\n* API response:\n\n" . htmlspecialchars($response) . "\n\n* App data array:\n\n" .
				print_r($appdata, true) . "\n\n----------------------------------------------------------------</pre>";
		}
		return $appdata; // this can be a PHP array, JSON or XML, depending on the $data['format'] value

	// Invalid shop ID?
	} else {
		die('Error: invalid Shop ID');
	}
}
?>
